<?
  //Indigo Form Mail Version Number:
  $version = "1.06";

//  error_reporting(E_ALL);  //Report all errors
  error_reporting(0);      //Report no errors

  /*
  The following are variables that can be set from the users's (referer) page.

  enable_underscore	Disables program to replace underscores with
			spaces for the field names.

  required		Fields required for non-error status

  sort			[rev,alpha] For Alphabetical sorting.

  redirect		[uri/url] Redirection location on valid form

  redirect_values	[1] On redirection, include variable values

  redirect_errors	[1] Redirect errors in X_ form to referer

  redirect_values_on_error_as_post	[1] When redirecting on error, create form so values are POSTed. Default is GET.

  redirect_values_on_success_as_post	[1] When redirecting on success, create form so values are POSTed. Default is GET.

  error_redirect	[uri/url] Redirect on form error. Default is referer.

  print_blank_fields	[1] Display fields that are left empty.

  hidden_fields		[CSV] List of fields NOT to be displayed in recipients E-mail

  no_redirect		[CSV] On redirection, exclude these variable values

  hide_html_var_names	[1] When passing HTML into script, this hides the field name.

  uu_decode		[CSV] List of variables for which to do a base_64 decode on.

  ifm_smime_enable	[1] Send out message encrypted using S/MIME. Requires ifm_smime_cert.

  ifm_smime_cert	ASCII version of the S/MIME certificate. To read an exported PFX file
			use the following command. Pull the certificate from the chain.txt file.
			openssl pkcs12 -in testcert.pfx -out chain.txt

  form_relative_redirect	Makes redirect string relative to the form, not the IFM script.

  ifm_send_form		Fetches a page via POST (of all incoming variables from form) and sends
			the HTML in the body of the e-mail. This allows smart forms to be mailed
			directly to the recipient.

  TEMPLATES:
  Templates can be used, provided they are passed in as a variable. We do not
  allow the selection of files as templates directly from the script, as this
  could cause security problems. Strings to be replaced with the templates
  should be of the format {!--String_Name--!}. Replaces all spaces and periods
  in var names with an underscore "_". Be sure to use correct case on letters!

  html_template		String containing template for HTML to be used in e-mail

  text_template		String containing template for text to be used in e-mail

  display_template	String containing template to be displayed at end of script

  BACKWARD COMPATIBILITIES:
  
  env_report		Environment data is included by default in the
			header of e-mails. You can view this by turning
			on "Rich Header" or "Detailed Header" in your e-mail
			client. The env_report variable never needs to be set.

REVISION HISTORY:
001.06 Added ability to simulate form POSTs.
       QP Encoding on HTML to help filter rogue chars

001.05 Added form_relative_redirect.
       Modified to use the "mail" function rather than sendmail pipe.
       Error message if UCE detection enabled, but no DB support.
       Mods to provide better compatibility on Windoze Operating Shells.
       Fixed bug that allowed accidential over-write of suject, recipient, realname

001.04 Changed value redirection to support mutiple select.
       This implements the $_REQUEST method and may make version 1.04
       incompatible with older version of PHP.

001.03 Added support for S/MIME encrypted messages
       Auto-detection of sendmail
       Major fixes to MIME-layout of e-mail

001.02	If no recipient is detected, get info from SERVER_ADMIN variable
	Cleaned up mail header variables
  */

  //Below is a list of defaults that iformmail is set to. You may edit these
  //as needed. They CANNOT be set from the referer HTML for security reasons.

  /* Location of sendmail. Or, if you use something like qmail, the 
     sendmail emulator. This hasn't been tested with qmail. Reports are 
     apreciated!
   */
   $sendmail_bin = ini_get("sendmail_path");

  /* To further deter UCE Clients, by default, we will not allow multiple recips. */
  $enable_mr = 0;

  /* By default a GET (iformail.php?recipient=sol@rosenberg.com&message=hello)
     is NOT allowed. A GET can allow UCE clients to easily abuse this script.
  */
  $allow_get = 0;

  /* Check to make sure the referer (HTML Form) is on the same URL
     as this PHP script. This helps prevent posting from another machine as
     is common with UCE clients. This can be fooled by a forged header and
     is not completely reliable. It may also fail with some clients as they
     may not send the referer. However, it does add another level of UCE 
     protection.
  */
  $strict_referer = 1;

  /* We use a database system to keep track of who uses this script. If a
     particular client accesses this too frequently, they are probably a
     UCE client, and we disable them.
     uce_db_enable - Turn DB tracking of IPs on. RECOMMENDED!
     uce_db_file - Database file. Contains IPs and times the accessed script.
     uce_db_secs - Amount of seconds to store IP and time in database.
     uce_db_threshold - How many times UCE client must hit script in 
                        uce_db_secs before being disabled.
  */
  $uce_db_enable = 0;  
  $uce_db_file = "/tmp/.iformmail_uce_log.db";  
  $uce_db_secs = 3600;  
  $uce_db_threshold = 7;  

  /* When adding multiple values to a variable (such is the case with
     multiple-select menu boxes), add this seperator BEFORE appending
     additional variables.
  */
  $mv_seperator=", ";

  /* Enable all Environment variables to be included in the header of the
     email. "X-" always prepends variable name in header.
  */
  $env_in_header = 0;

  /* Enable all Server variables to be included in the header of the
     email. "X-" always prepends variable name in header.
  */
  $server_in_header = 1;


  /* If a variable ends in .HTML, allow it to be included AS HTML. */
  $allow_html_include = 1;

  /* When passing variables back to the referer or another script, 
     prefix with this.
  */
  $var_prefix = "X_";	

  //When passing points of failure to a script prefix with this.
  $fail_prefix = "X_failed_";

  /* When replacing text on a template, using the following tokens to detect
     user variables. By default, text as "!--name--!" on a template would be
     replaced by form variable "name".  
  */
  $temp_tok_pre = "!--"; //Text before variable. Default "!--".
  $temp_tok_post = "--!"; //Text after variable. Default "--!".


  /*
    If $allow_client_db_dump is enableled, and PHP script is called with
    show_db_dump=1 (such as "iformmail.php?show_db_dump=1") then database
    of recently connected clients will be displayed in an HTML table.
    You probably DO NOT want people to see which client IP addresses recently
    connected to your computer! Do NOT enable this unless you know what you're
    doing.
  */
  $allow_client_db_dump = 0; //DO NOT ENABLE/SECURITY REASONS. TEST PURPOSES ONLY!

  /* If no recipient is specified allow script to auto-detect recipient
     by using the SERVER_ADMIN variable
  */
  $allow_sa_fallback = 1;

  /* Restrict recipient domain to the following comma-delimited list.
     For example "digitalindigo.com,digitalindigo.net,vertexinternet.com" 
  */
  //UNIMPLEMENTED

  //---END USER EDITABLE VARIABLES----------------------------------------

  if (!function_exists('dba_open') && $uce_db_enable) 
  {
    die("ERROR: You have UCE detection turned on, but no Database support. Set uce_db_enable variable to false, compile DB support into your PHP binary.");
  }

  function is_required() 
  {
    print $HTTP_POST_VARS['required'];
  }

  function phpize_vname($vn)
  {
    /* Accepts a variable name and then replaces any spaces or periods
       with an "_". For instance a variable name called code.html is
       stored as "code_html" in PHP. This function matches that name.
    */
    $vn=ereg_replace("[[:space:]]","_",$vn);
    $vn=ereg_replace("\.","_",$vn);
    return($vn);
  }


  function post_url($datastream, $url) { 
    /*
TODO:
This fetches a URL, simulating a POST. The data is then returned via string.
Needs some work yet.
    */
    $url = preg_replace("@^http://@i", "", $url);
    $host = substr($url, 0, strpos($url, "/"));
    $uri = strstr($url, "/"); 
    $result = "";
    $reqbody = "";
    foreach($datastream as $key=>$val) {
      if ($reqbody) $reqbody.= "&";
      $reqbody.= $key."=".urlencode($val);
    } 
    $contentlength = strlen($reqbody);
    $reqheader =  "POST $uri HTTP/1.0\r\n".
     "Host: $host\n". "User-Agent: PostIt\r\n".
     "Content-Type: application/x-www-form-urlencoded\r\n".
     "Content-Length: $contentlength\r\n\r\n".
     "$reqbody\r\n"; 
   $socket = fsockopen($host, 80, $errno, $errstr);
   if (!$socket) {
      $result["errno"] = $errno;
      $result["errstr"] = $errstr;
      return $result;
    }

    $be = 0; //Buffer Enable (to store data from file stream)
    fputs($socket, $reqheader);
    while (!feof($socket)) 
    {
      //This area gets rid of header information returned from the HTTP fetch
      $fd = fgets($socket, 4096);
      if(strlen($fd) < 3) {$be++;}
      if($be) {$result .= $fd;}
    }
    fclose($socket);
    return $result;
  }


  function get_web_var($vn)
  {
    /* 
	Returns the value of variable $vn from web_var's array.
        This is used to address the problem of referencing unindexed
        keys.
    */

    global $web_vars;
    $ret = NULL;
    if(array_key_exists($vn, $web_vars))
    {
      $ret = $web_vars[$vn];
    }
    return($ret);
  }

  function get_arr_var($arr,$vn)
  {
    /* 
	Returns the value of variable $vn from an array, $arr.
        This is used to address the problem of referencing unindexed
        keys.
    */

    global ${$arr};
    $ret = NULL;
    if(array_key_exists($vn, ${$arr}))
    {
      $ret = ${$arr}[$vn];
    }
    return($ret);
  }


  function qp_encoding($Message) {
    /* Build (most polpular) Extended ASCII Char/Hex MAP (characters >127 & <255) 
     Thanks to the contributor on PHP.net for this function
    */
    for ($i=0; $i<127; $i++) {
      $CharList[$i] = "/".chr($i+128)."/";
      $HexList[$i] = "=".strtoupper(bin2hex(chr($i+128)));
    }

    /* Encode equal sign & 8-bit characters as equal signs followed by their hexadecimal values */
    $Message = str_replace("=", "=3D", $Message);
    $Message = preg_replace($CharList, $HexList, $Message);

    /* Lines longer than 76 characters (size limit for quoted-printable Content-Transfer-Encoding)
       will be cut after character 75 and an equals sign is appended to these lines. */
    $MessageLines = split("\n", $Message);
    $Message_qp = "";
    while(list(, $Line) = each($MessageLines)) {
      if (strlen($Line) > 75) {
        $Pointer = 0;
        while ($Pointer <= strlen($Line)) {
          $Offset = 0;
          if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+73), 3))) $Offset=-2;
          if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+74), 3))) $Offset=-1;
          $Message_qp.= substr($Line, $Pointer, (75+$Offset))."=\n";
          if ((strlen($Line) - ($Pointer+75)) <= 75) {
            $Message_qp.= substr($Line, ($Pointer+75+$Offset))."\n";
            break 1;
          }
          $Pointer+= 75+$Offset;
        }
      } else {
        $Message_qp.= $Line."\n";
      }
    }
    return $Message_qp;
  }

  function format_key($key,$enable_underscore) 
  {
    //Let's make the underscores in variable names into spaces, 
    //unless specified otherwise.
    if($enable_underscore) 
    {
      $m_key=$key;
    }else{
      $m_key=str_replace("_"," ",$key);
    }
    return($m_key);
  }

  function getmicrotime()
  { 
    //Return the UNIX time, with microseconds
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
  } 

  function ip_uce_check($filename,$ip_secs,$ip)
  {
    /*
      Creates a database file and logs the IP and time of each request.
      Function accepts the database filename, the number of seconds to
      store an IP, and the IP address. The function will then return how
      many hits have occured from IP in IP_SECS period of time.

      TODO: Check if this needs file locking.
    */
    $ht = 0;  //Init amount of times this IP has hit, according to DBA.
    $verbose = 0; //Debugging only
    $dba = dba_open("$filename", "w", "gdbm");

    if (!$dba) {
      echo "ERROR: Could not open DBA.\n";
      exit;
    }

    $da = array();
    $key = dba_firstkey($dba);
    $dt = date("U")-$ip_secs;  //Delete all records before this UNIX time.
    if($verbose) {print "Deleting records before $dt.\n";}
    while($key != false) {
      if($verbose) {print "-------\nScanning record $key.\n";}
      $this_ip = dba_fetch($key,$dba);
      if($key < $dt) {
        //Key is past expiration date. Expunge.
        array_push($da,$key);
        if($verbose) {print "Expired $key.\n";}
      }else{
        if($this_ip == $ip) 
        {
          $ht++;
          if($verbose) {print "Incrementing $this_ip from key $key, value $ht.\n";}
        }else{
          if($verbose) {print "Ignoring $key, IP $this_ip.\n";}
        }
      }
      $key = dba_nextkey($dba);
      if($verbose) {print "Nextkey is $key.\n";}
    }
    dba_replace (getmicrotime(), $ip, $dba);
    foreach ($da as $dr) {
      dba_delete($dr,$dba);
      if($verbose) {print "Cleanup deleting $dr.\n";}
    }
    dba_close ($dba);
    return($ht);
  }


  function client_db_dump($filename,$ip)
  {
    /*
      Creates a table that displays all the contents of the UCE database
      in human readable contents.
    */
    $dba = dba_open("$filename", "ro", "gdbm");

    if (!$dba) {
      echo "ERROR: Could not open DBA.\n";
      exit;
    }

    $da = array();
    $key = dba_firstkey($dba);
    $gd = date("Y-m-d D"); //Generated date
    $gt = date("H:i:s");  //Generated time
    print "<table border=1 cellpadding=5 cellspacing=0> \n";
    print "<tr><td colspan=3><b>Generated on $gd at $gt.</b></td></tr> \n";
    while($key != false) {
      $this_ip = dba_fetch($key,$dba);
      list($ut) = explode(".",$key); //Put the unixtime integer into a variable.
      $dd = date("Y-m-d D",$ut);
      $dt = date("H:i:s",$ut);
      print "<tr><td>$dd</td><td>$dt</td><td>$this_ip</td></tr> \n";
      $key = dba_nextkey($dba);
    }
    dba_close ($dba);
    print "</table>\n";
    return(0);
  }


//MAIN------
  //INITIALIZERS --- DO NOT EDIT!
  $client_ip = $HTTP_SERVER_VARS{'REMOTE_ADDR'}; //IP Addr of client.
  $hostname = $HTTP_SERVER_VARS{'HTTP_HOST'}; //Hostname/IP of host.
  $ref_url = get_arr_var('HTTP_SERVER_VARS','HTTP_REFERER'); //Referrer (if any) URL
  $text_body=""; 	//The body of the email in text form.
  $html_body=""; 	//The body of the email in HTML form.
  $post_pass="";	//All the incoming data in a POST method format.
  $get_pass="";		//All the incoming data in a GET method format.
  $pv_count=0;		//Post variables count.
  $boundary = "--=DigitalIndigo_Multipart_DITMP1.0";	//MIME Boundary Marker.
  $th_bound = "_TH_Part_"; //Addition to MIME Boundary on Text/HTML part.
  $post_s = ""; //String containing all variables posted
  $vals_uri = ""; //String in URI format containing data posted/getted to this script.
  $required_uri = ""; //String with required fields information in URI format;

  //If allowed, and requested, print table of recent client connects.
  if($allow_client_db_dump && $_REQUEST[show_db_dump]) 
  {
    client_db_dump($uce_db_file,"");
    exit();
  }

  //Check referer versus script server.
  if($strict_referer)
  {
    if(isset($ref_url)) {
      $ref_url_parsed = parse_url($ref_url);
      $ref_host = $ref_url_parsed['host'];
    }else{
      $ref_host = "UNAVAILABLE";
    }

    if(!(eregi("$ref_host$",$hostname)||eregi("$hostname$",$ref_host)))
    {
      print "We don't allow forms from other servers. Your form was from $ref_host and this script is on $hostname.";
      exit();
    }
  }


  /* GETs are an evil combo with UCE Clients. Since we don't know who
     to trust. So by all means STOP a GET, unless the user says otherwise.
     Promote physical violence towards UCE Clients.
  */
  if(!$allow_get && $HTTP_SERVER_VARS{'REQUEST_METHOD'}!="POST")
  {
    print "GETs are not allowed.";
    exit();
  }


  //Make sure client hasn't used this script too frequently lately.
  if($uce_db_enable)
  {
    //Do not compount above if statement with following. This may cause errors on systems without db support.
    if(ip_uce_check("$uce_db_file",$uce_db_secs,$HTTP_SERVER_VARS{'REMOTE_ADDR'})>$uce_db_threshold)
    {
      print "You have been identified as a possible UCE client. Your form was NOT processed. Please try again later.";
      exit();
    }
  }


  //Create an associative array of variables to be base64 decoded.
  $uu_decode = phpize_vname($_REQUEST['uu_decode']);
  $uu_list=split(",",$uu_decode);
  foreach($uu_list as $uu_tok) 
  {
    $ud[$uu_tok]=1;
  }

  /* Put both GET and POST vars into one container.
     Newer version of PHP have this builtin. But we do it the old 
     way for compatibility.
  */


  function insert_vals($key,$val)
  {
    global $ud;
    global $web_vars;
    global $mv_seperator;
    if(get_arr_var('ud',$key)) {
      $val = base64_decode($val); 
    }
    /* We look to see if value is an array. This is used in multi-select
       drop boxes, with syntax:
        <select name="some_list[]" size="10" multiple>
       IMPORTANT: Note the [] after varible name in HTML. This indicates
       to PHP that it is a multiple select.
    */
    if(is_array($val))
    {
      foreach ($val as $ms_val)
      {
        if($web_vars[$key]) {$mvs=$mv_seperator;}else{$mvs="";}
        $web_vars[$key].=$mvs.$ms_val;
      }
    }else{
      $web_vars[$key]=$val;
    }
  }



  reset ($HTTP_POST_VARS);
  while (list ($key, $val) = each ($HTTP_POST_VARS)) 
  {
    insert_vals($key,$val);
  }

  /* This keeps any data from being loaded should someone try something
     sneaky--like a POST and GET at the same time.
  */
  if($allow_get)
  {
    reset ($HTTP_GET_VARS);
    while (list ($key, $val) = each ($HTTP_GET_VARS)) 
    {
      insert_vals($key,$val);
    }
  }  

  //DETECT ADDITIONAL ERRORS

  //If no recipient is specified, set recip to the SERVER_ADMIN address
  if(!get_web_var('recipient') && $allow_sa_fallback) {
    $web_vars['recipient'] = $HTTP_SERVER_VARS{'SERVER_ADMIN'};
  }

  //We must have a destination for which to send the e-mail
  if(!get_web_var('recipient')) {die ('Mail recipient is required.');}

  //Don't allow multiple recips, if disabled.
  if(strstr($web_vars['recipient'],",") && !$enable_mr) {
    die ('Sending to multiple recipients is not enabled.');
  }


  $no_display = get_web_var('hidden_fields');

  //List of vars to not be displayed
  $no_display.=",MAX_FILE_SIZE,realname,email,recipient,subject,";
  $no_display.="enable_underscore,required,sort,redirect,error_redirect,";
  $no_display.="redirect_values,redirect_errors,print_blank_fields,";
  $no_display.="hide_html_var_names,uu_decode,hidden_fields,text_template,";
  $no_display.="html_template,display_template,html_redirect,";
  $no_display.="ifm_smime_cert,ifm_smime_enable,redirect_values_on_error_as_post,";
  $no_display.="redirect_values_on_success_as_post,form_relative_redirect,";

  //Create an associative array of hidden tokens
  $no_display=phpize_vname($no_display);
  $nd_list=split(",",$no_display);
  foreach($nd_list as $nd_tok) 
  {
    $nd_tok=strtolower($nd_tok);
    $hide[$nd_tok]=1;
  }


  //Sort fields alphabetically or rev alpha, if requested
  if(eregi("^alp",get_web_var('sort'))) 
  {
    ksort($web_vars);
  }elseif(eregi("^rev",get_web_var('sort'))) {
    krsort($web_vars);
  }

  //Find Failed Requirements
  $failed_field=array();	//Stack of fields that required data, but failed.
  if(get_web_var('required')) 
  {
    $req_a=split(",",get_web_var('required'));
    foreach($req_a as $requirement) 
    {
      $requirement=ereg_replace("[[:space:]]","_",$requirement);
      if(!get_web_var($requirement)) 
      {
        $required_uri.="&".$var_prefix."failed_$requirement=1";
        $m_req=format_key($requirement,get_web_var('enable_underscore'));
        array_push($failed_field,"$m_req");
        $post_s.="<input type=\"hidden\" name=\"".$fail_prefix."$requirement\" value=\"1\">\n";
      }
    }
  }


  //If requested, make redirect relative to form
  if(get_web_var('form_relative_redirect'))
  {
    $ref_dir = dirname($ref_url);
    $redirect_ex_path = $ref_dir."/";  //Extra path info to add to redirect
  }

  //Create an associative array of variables not to be redirected.
  $no_redir=phpize_vname(get_web_var('no_redirect'));
  $nr_list=split(",",$no_redir);
  foreach($nr_list as $nr_tok) 
  {
    $nr_tok=strtolower($nr_tok);
    $redir_exclude[$nr_tok]=1;
  }

  reset ($web_vars);
  while (list ($key, $val) = each ($web_vars)) 
  {
    //print "KEY $key : VALUE $val <br>\n";
    //Fetch these variables regardless of case
    if(eregi("^realname$",$key)) {$realname=$val;}
    if(eregi("^subject$",$key)) {$subject=$val;}
    if(eregi("^email$",$key)) {$email=$val;}
    if(eregi("^recipient$",$key)) {$recipient=$val;}


    if( (get_web_var('print_blank_fields') || $val) && !(get_arr_var('hide',strtolower($key))) )
    {
      $m_key=format_key($key,get_web_var('enable_underscore'));
      $val = stripslashes($val); //Get rid of those annoyances before " and '
      if(eregi("_html$",$key) && $allow_html_include) {
        /* If a variable ends in .HTML, we'll pass that HTML directly
           on to the web formatted e-mail section. Or we'll strip the
           HTML tags for the raw text version.
        */
        $text_body.="$m_key: ".strip_tags($val)."\n\n";
        if(!get_web_var('hide_html_var_names')) {
          //The user may not want to see the field name above HTML they post.
          $html_body.="<b>$m_key:</b>\n<br>\n";
        }
        $html_body.= $val."<br><br>";
      }else{
        $text_body.="$m_key: $val\n\n";
        $html_body.="<b>$m_key:</b> ".nl2br(htmlentities($val))."\n<br><br>";
      }
    }
    $post_s .= "<input type=\"hidden\" name=\"$key\" value=\"".htmlentities($val)."\">\n";
    if($pv_count) {$vals_uri.="&";}
    if(array_key_exists(strtolower($key), $redir_exclude) && !$redir_exclude[strtolower($key)]) {
      if(is_array($_REQUEST[$key]))
      {
        $ravc = 0; //Redirect array value count
        foreach ($_REQUEST[$key] as $val)
        {
          if($ravc) {$vals_uri.="&";}
          $vals_uri.=htmlentities(urlencode($key))."[]=".htmlentities(urlencode($val));
          $ravc++;
        }
      }
      else
      {
        $vals_uri.=htmlentities(urlencode($key))."=".htmlentities(urlencode($val));
      }
    }
    $pv_count++;
  }



  //print "Text Body:<br><pre>$text_body</pre><hr>HTML Body:<br>$html_body";

  //Let's fill in any templates
  if(get_web_var('html_template') || 
     get_web_var('text_template') || 
     get_web_var('display_template')) 
  {
    $html_template = get_web_var('html_template');
    $text_template = get_web_var('text_template');
    $display_template = get_web_var('display_template');
    reset ($web_vars);
    while (list ($key, $val) = each ($web_vars)) 
    {
      $rep_tok = $temp_tok_pre.$key.$temp_tok_post;  //Replace this text
      $clr_tok = $temp_tok_pre.".*".$temp_tok_post; //After processing clear all remaining tokens
      $html_template = eregi_replace($rep_tok,"$val",$html_template);
      $text_template = eregi_replace($rep_tok,"$val",$text_template);
      $display_template = eregi_replace($rep_tok,"$val",$display_template);
    }

    //Clear out any tags that weren't replaced.
    $html_template = eregi_replace($clr_tok,"",$html_template);
    $text_template = eregi_replace($clr_tok,"",$text_template);
    $display_template = eregi_replace($clr_tok,"",$display_template);

    //Load template into variable if it exists (Only do this for text version)
    if($text_template) {$text_body = $text_template;}
  }

  //List fields that were required, but left empty by user
  if($failed_field && get_web_var('redirect_errors')) 
  {
    if(get_web_var('error_redirect')) {
      $location=$web_vars['error_redirect'];
    }else{
      list($location)=split('\?',$HTTP_SERVER_VARS{'HTTP_REFERER'});
    }
    $location.="?".$required_uri."&";
    if(get_web_var('redirect_values')) 
    {
      $location.=$vals_uri;
    }
    if(get_web_var('redirect_values_on_success_as_post'))
    {
      print "<form enctype=\"multipart/form-data\" method=\"POST\" action=\"".$ref_url."\"> \n";
      print $post_s;
      print "<input type=\"submit\" value=\"Continue -&gt;&gt;\"> \n";
      print "</form> \n";
    }
    else
    {
      header("Location: $location");
    }
    exit();
  }elseif($failed_field){
    if(get_web_var('redirect_values_on_error_as_post'))
    {
      $button_name = "Return To Form";
    }
    else
    {
      $button_name = "Back";
    }

    print "The following fields are required, please click the ".$button_name." button and fill in all required information.<br>\n<ul>\n";
    foreach($failed_field as $ff) 
    {
      print "<li>$ff</li>\n";
    }
    print "</ul>\n";
    if(get_web_var('redirect_values_on_error_as_post'))
    {
      print "<form enctype=\"multipart/form-data\" method=\"POST\" action=\"".$ref_url."\"> \n";
      print $post_s;
      print "<input type=\"submit\" value=\"Return To Form\"> \n";
      print "</form> \n";
    }
    exit();
  }

  //Mail variables
  $mail_header_base="";  // The base header components (To, From, Subject)
  $mail_header_extra = ""; //Extra header info (boundary, MIME types, extra info)
  $mail_body = "";  //The body of text, HTML, MIME attachments

  //Create the e-mail header.
  $from = ""; //E-mail address of sender
  $mail_header_base = "To: ".$recipient."\n";
  if($email) 
  {
    if(!isset($realname)) {$realname = "Web Form";}
    $from = $realname." <".$email.">";
    $mail_header_base .= "From: ".$realname." <".$email.">\n";
  }
  if($subject) {$mail_header_base .= "Subject: ".$subject."\n";}
  $mail_header_extra .= "MIME-Version: 1.0\n";
  $mail_header_extra .="Content-Type: multipart/mixed; \n\tboundary=\"$boundary\"\n";
  $mail_header_extra .="Content-Transfer-Encoding: 7bit\n";
  $mail_header_extra .="X-Mailer: Digital Indigo iFormMail $version\n";

  //Include ENV variable information.
  if($env_in_header) {
    foreach($HTTP_ENV_VARS as $key => $value)
    {
      $mail_header_extra .="X-ENV-".$key.": ".rtrim($value)."\n";
    }
  }

  //Include Server variable information.
  if($server_in_header) {
    foreach($HTTP_SERVER_VARS as $key => $value)
    {
      if(!is_array($value)) {
        //TODO: Currently we don't print SERVER_VARS that are arrays.
        $mail_header_extra .="X-SERVER-".$key.": ".rtrim($value)."\n";
      }
    }
  }

  $mail_header_extra .="X-OPEN_SOURCE_ROCKS: Definitely!";
  $mail_header_extra .="\n\n";

  //Create the e-mail
  $mail_body .= "This is a multi-part message in MIME format.\n";
  $mail_body .= "\n--$boundary\n";
  $mail_body .= "Content-Type: multipart/alternative; \n\tboundary=\"".$boundary.$th_bound."\"\n\n";
  $mail_body .= "\n--".$boundary.$th_bound."\n";
  $mail_body .= "Content-type: text/plain;\n\tcharset=\"iso-8859-1\"\n";
  $mail_body .= "Content-Transfer-Encoding: 7bit\n\n";
  $mail_body .= "$text_body\n";
  $mail_body .= "\n\n--".$boundary.$th_bound."\n";
  $mail_body .= "Content-type: text/html;\n\tcharset=\"iso-8859-1\"\n";
  $mail_body .= "Content-Transfer-Encoding: quoted-printable\n\n";

  if(isset($html_template)) {
    $mail_body .= qp_encoding($html_template);
  }elseif(get_web_var('ifm_send_form')) {
    $mail_body .= qp_encoding(post_url($_POST,get_web_var('ifm_send_form')));
  }else{
    $mail_body .= qp_encoding($html_body);
  }
  $mail_body .= "\n\n--".$boundary.$th_bound."--\n";

  $file_count=0;

  foreach($HTTP_POST_FILES as $key => $val) 
  {
    $tmp_file=$HTTP_POST_FILES[$key]['tmp_name'];
    if($HTTP_POST_FILES[$key]['size']) 
    {
      $mail_body .= "\n--$boundary\n";
      $mail_body .= "Content-Type: ".$HTTP_POST_FILES[$key]['type'];
      $mail_body .= "; \n\tname=\"".$HTTP_POST_FILES[$key]['name']."\"\n";
      $mail_body .= "Content-Transfer-Encoding: base64\n";
      $mail_body .= "Content-Disposition: attachment; \n\tfilename=\"".$HTTP_POST_FILES[$key]['name']."\"\n";
      $mail_body .= "\n";
      $buf="";
      $fp = fopen("$tmp_file","r");
      if($fp) {
        $file_count++;
        while (!feof($fp)) {
          $buf .= fgetc($fp);
        }
      }
      fclose($fp);
      $mail_body .= chunk_split(base64_encode($buf));
      $mail_body .= "\n";
    }
  }
  $mail_body .= "\n--$boundary--\n";

  if(get_web_var('ifm_smime_enable'))
  {
    if(!get_web_var('ifm_smime_cert')) 
    {
      print "Error! No certificate found in ifm_smime_cert.";
      exit();
    }

    //Encrypt this body according to S/MIME specification
    //Thanks to glyn for posting to the PHP website with this trick on dealing with temp file names
    $clearfile = tempnam("temp","email") . ".txt";
    $encfile = $clearfile . ".enc";
    $clearfile .= ".txt";

    $fp = fopen($clearfile, "w");
    fwrite($fp, $mail_header_extra.$mail_body);
    fclose($fp);

    if (openssl_pkcs7_encrypt($clearfile, $encfile, $web_vars['ifm_smime_cert'],
       array()))
    {
      $enc_file_array = file($encfile);
      $enc_file_content = implode("", $enc_file_array);
      mail($recipient,$subject,"","From: ".$from."\n".$enc_file_content);
    }
    unlink($clearfile);
    unlink($encfile);
  }
  else
  {
    //Send e-mail normally (not encrypted)
      mail($recipient,$subject,$mail_body,"From: ".$from."\n".$mail_header_extra);
  }


  if(get_web_var('redirect')||get_web_var('html_redirect')) 
  {
    $location_uri="";
    if(get_web_var('redirect_values')) {
      $location_uri="?".$vals_uri;
    }
    if(get_web_var('html_redirect')) {
      $redir_location=$redirect_ex_path.$web_vars['html_redirect'].$location_uri;
      print "To continue ";
      print "<a href=\"".$redir_location."\">click here</a>.\n";
    }else{
      $redir_location=$redirect_ex_path.$web_vars['redirect'].$location_uri;
      header("Location: ".$redir_location);
    }
  }elseif(isset($display_template)) {
    print $display_template;
  }else{
    print $html_body;
  }
?>
